#include "header/main_thread.h"

void main_thread(){
	int i;
	int state;//状態を示す
	int dir_step_mt;	//ステッピングモータの角度を格納する変数
	int map_data[LENGTH_OF_MAP][LENGTH_OF_MAP];		//mapデータ収納配列
	map_store_read(map_data,LENGTH_OF_MAP*LENGTH_OF_MAP);	//mapデータを収納

	int uss_dist_data_e[LENGTH_OF_USS_MAP][LENGTH_OF_USS_MAP];	//データ収納配列東
	int uss_dist_data_s[LENGTH_OF_USS_MAP][LENGTH_OF_USS_MAP];	//データ収納配列南
	int uss_dist_data_w[LENGTH_OF_USS_MAP][LENGTH_OF_USS_MAP];	//データ収納配列西
	int uss_dist_data_n[LENGTH_OF_USS_MAP][LENGTH_OF_USS_MAP];	//データ収納配列北
	map_store_read(map_data,LENGTH_OF_MAP*LENGTH_OF_MAP);		//mapデータを収納
	map_store_uss_dist_data_read(uss_dist_data_e,0);		//ussデータを収納
	map_store_uss_dist_data_read(uss_dist_data_s,1);		//ussデータを収納
	map_store_uss_dist_data_read(uss_dist_data_w,2);		//ussデータを収納
	map_store_uss_dist_data_read(uss_dist_data_n,3);		//ussデータを収納

	int pos_esti;	//直列の自己座標
	int pos[2];	//ベクトルの自己座標

	extern double extern_img_dist;	//大域変数 距離
	extern int extern_img_area;		//大域変数 エリア

	extern int extern_motor_vector[2];	//大域変数 {速度,角度(degree)}

	extern int extern_camera_state;	//大域変数 0:怪盗なし 1:怪盗あり

	int dir=-1;//進行方向 1234=東南西北 -1:停止

	while (1){
//デバグ		printf("main ");
		if (extern_img_area==0){	//カメラ内に怪盗が存在しない
			state=0;
			extern_camera_state=0;	//大域変数 怪盗なし
			pos_esti=pos_estimate(map_data,uss_dist_data_e,uss_dist_data_s,uss_dist_data_w,uss_dist_data_n);	//自己位置認識
			pos[0]=pos_esti%LENGTH_OF_MAP;	//自己位置分割x
			pos[1]=pos_esti/LENGTH_OF_MAP;	//自己位置分割y

			dir=route_serch_dir(pos_esti,CENTER_OF_THE_MAP+CENTER_OF_THE_MAP*LENGTH_OF_MAP,map_data);	//中央をゴールにして経路作成
			if (dir==-1){	//中央にいる
				state=1;
				extern_motor_vector[0]=0;//タイヤを止める
				dir_step_mt=step_motor_arg(0);//ステッピングモータを旋回モードで回し、角度を取得
			}else {	//中央にいない
				state=2;
				extern_motor_vector[0]=100;//タイヤを回す
				extern_motor_vector[1]=dir*(-90);//方向を決める
			}
		}else{				//カメラ内に怪盗を発見した
			extern_camera_state=1;	//大域変数 怪盗あり
			state=3;
			extern_motor_vector[0]=100;//タイヤを回す
			extern_motor_vector[1]=dir_step_mt+(extern_img_area-2)*15;//方向を決める
		}

		usleep(1000*10);
		printf("%d\n",state);
	}
}

