//--------------------------------------------------------------- 
//【関数名　】：polygonDetect (未完成)
//【処理概要】：ポリゴン抽出 
//【引数　　】：src_img      = 入力画像(二値画像) 
//　　　　　　：dst_img      = 出力画像(二値画像) 
//　　　　　　：strage       = ストレージ
//　　　　　　：n	    = 検出する図形の辺の数
//　　　　　　：area_min     = 最小領域面積
//　　　　　　：area_max     = 最大領域面積

//【戻り値　】：なし 
//【備考　　】：
//---------------------------------------------------------------

void polygonDetect{IplImage *src_img,IplImage *dst_img,CvMemStroge *strage,int n,int area_min,int area_max）｛
	CvSeq *contours=NULL;

	//輪郭検出
	cvFindContours(imgIn,strage,&contours,sizeof(CvContour),CV_RETR_LIST,CV_CHAIN_APPROX_SIMPLE,cvPoint(0,0));
	if(!contours) return;
	//検出された輪郭線に対する処理
	for(CvSeq* c=contours;c!=NULL;c=c->h_next){
		double area=abs(cvContourArea(c,CV_WHOLE_SEQ));

	//領域の大きさをチェック
	if((area>area_min)&&(area<area_max)){
	//輪郭線の			















		IplImage *dst_img1, *dst_img2, *dst_img3;
  		IplImage *tmp_img;



  tmp_img = cvCreateImage (cvGetSize (src_img), IPL_DEPTH_16S, 1);
  dst_img1 = cvCreateImage (cvGetSize (src_img), IPL_DEPTH_8U, 1);
  dst_img2 = cvCreateImage (cvGetSize (src_img), IPL_DEPTH_8U, 1);
  dst_img3 = cvCreateImage (cvGetSize (src_img), IPL_DEPTH_8U, 1);

  // (2)Sobelフィルタによる微分画像の作成
  cvSobel (src_img, tmp_img, 1, 0,3);//1,3,5,7
  cvConvertScaleAbs (tmp_img, dst_img1,1.0,0.0);

  // (3)画像のLaplacianの作成
  cvLaplace (src_img, tmp_img,3);
  cvConvertScaleAbs (tmp_img, dst_img2,1.0,0.0);

  // (4)Cannyによるエッジ画像の作成
  cvCanny (src_img, dst_img3, 50.0, 200.0,3);

  // (5)画像の表示
//  cvNamedWindow ("Original", CV_WINDOW_AUTOSIZE);
//  cvShowImage ("Original", src_img);
// cvWaitKey (0);
//  cvNamedWindow ("Sobel", CV_WINDOW_AUTOSIZE);
//  cvShowImage ("Sobel", dst_img1);
//  cvWaitKey (0);
//  cvNamedWindow ("Laplace", CV_WINDOW_AUTOSIZE);
//  cvShowImage ("Laplace", dst_img2);
// cvWaitKey (0);
  cvNamedWindow ("Canny", CV_WINDOW_AUTOSIZE);
  cvShowImage ("Canny", dst_img3);
  cvWaitKey (0);

//  cvDestroyWindow ("Original");
//  cvDestroyWindow ("Sobel");
//  cvDestroyWindow ("Laplace");
  cvDestroyWindow ("Canny");
  cvReleaseImage (&src_img);
  cvReleaseImage (&dst_img1);
  cvReleaseImage (&dst_img2);
  cvReleaseImage (&dst_img3);
