/*
ステッピングモータ制御回路に信号を送るモジュール
2014/12/16
*/
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <string.h>
#include <unistd.h>

#include <sys/io.h>

#include <pthread.h>

#include "header/step_motor.h"
#include "device.h"

void step_motor_ctl(char *step_ctl,int step)	//引数は0x01(正転時計)、0x02(逆転)
{

	int i;
	ioperm(IO_ADD,8,1);
	for(i=0;i<step;i++){
		outb(*step_ctl,IO_ADD);		
		usleep(1000);
		outb((char)0x00,IO_ADD);	//リセット
		usleep(100000);
	}
	
//		for(i=0;i<12;i++){
//	       		printf("I/O[%d] = %c\n",i+1,*io_data);
//		   	io_data++;
//	       	}

}

int step_motor_arg(int state){
	static int degree=0;
	static int dir=0x01;
	if (state==0){	//stateが0なら旋回
		if (dir==0x01){
			degree-=30;
		}else if (dir==0x02){
			degree+=30;
		}
		if (degree==180||degree==-180){dir=(dir==0x01)?0x02:0x01;}//方向転換
	}




	step_motor_ctl((char *)dir,4);

	if (degree<-180){degree+=360;}
	if (degree> 180){degree-=360;}


	return degree;//返り値は角度(degree)
}
