#include "header/test_pos.h"

int main (void){


//	test_map_read();
//	test_uss_dist_data_read();
//	test_pos_estimate();
//	test_route_serch();
	test_route_serch_to_center();

}


void test_map_read(void){
	int i,j;
	int map_data[LENGTH_OF_MAP][LENGTH_OF_MAP];	//mapデータ収納配列

	map_store_read(map_data,LENGTH_OF_MAP*LENGTH_OF_MAP);	//mapデータを収納

	for (i=0;i<LENGTH_OF_MAP;i++){for (j=0;j<LENGTH_OF_MAP;j++){	//二重ループにより出力
		printf ("%d ",map_data[i][j]);
		if (map_data[i][j]<9){printf(" ");}
	}printf("\n");}
}

void test_uss_dist_data_read(void){
	int i,j;
	int scan_dir;
	int uss_dist_data[LENGTH_OF_USS_MAP][LENGTH_OF_USS_MAP];	//データ収納配列

	printf("Please input number of direction\n 0:east  1:south  2:west  3:north\n\n");
	scanf("%d",&scan_dir);

	map_store_uss_dist_data_read(uss_dist_data,scan_dir);	//ussデータを収納

	for (i=0;i<LENGTH_OF_USS_MAP;i++){for (j=0;j<LENGTH_OF_USS_MAP;j++){	//二重ループにより出力
		if (uss_dist_data[i][j]>=0){printf(" ");}
		printf ("%d ",uss_dist_data[i][j]);
	}printf("\n");}
}

void test_pos_estimate(void){
	int i;
	int pos_est;
	int pos[2];
	int map_data[LENGTH_OF_MAP][LENGTH_OF_MAP];					//mapデータ収納配列	
	int uss_dist_data_e[LENGTH_OF_USS_MAP][LENGTH_OF_USS_MAP];	//データ収納配列東
	int uss_dist_data_s[LENGTH_OF_USS_MAP][LENGTH_OF_USS_MAP];	//データ収納配列南
	int uss_dist_data_w[LENGTH_OF_USS_MAP][LENGTH_OF_USS_MAP];	//データ収納配列西
	int uss_dist_data_n[LENGTH_OF_USS_MAP][LENGTH_OF_USS_MAP];	//データ収納配列北

	map_store_read(map_data,LENGTH_OF_MAP*LENGTH_OF_MAP);	//mapデータを収納
	map_store_uss_dist_data_read(uss_dist_data_e,0);		//ussデータを収納
	map_store_uss_dist_data_read(uss_dist_data_s,1);		//ussデータを収納
	map_store_uss_dist_data_read(uss_dist_data_w,2);		//ussデータを収納
	map_store_uss_dist_data_read(uss_dist_data_n,3);		//ussデータを収納

	pos_est=pos_estimate(map_data,uss_dist_data_e,uss_dist_data_s,uss_dist_data_w,uss_dist_data_n);
	pos[0]=pos_est%LENGTH_OF_MAP;
	pos[1]=pos_est/LENGTH_OF_MAP;

	printf("%d %d\n",pos[0],pos[1]);


	//printf("\n\n   %d\n",(pos_estimate()));
}

void test_route_serch(void){
	int start[2],goal[2];
	int dir;
	int map_data[LENGTH_OF_MAP][LENGTH_OF_MAP];	//mapデータ収納配列
	map_store_read(map_data,LENGTH_OF_MAP*LENGTH_OF_MAP);	//mapデータを収納
	

	printf("Please input start pos\nx:");
	scanf("%d",&start[0]);
	printf("y:");
	scanf("%d",&start[1]);

	printf("Please input goal pos\nx:");
	scanf("%d",&goal[0]);
	printf("y:");
	scanf("%d",&goal[1]);
/*
	goal[0]=CENTER_OF_THE_MAP;
	goal[1]=CENTER_OF_THE_MAP;
*/
	dir=route_serch_dir(start[0]+start[1]*LENGTH_OF_MAP,goal[0]+goal[1]*LENGTH_OF_MAP,map_data);
	printf("Direction of route is ");
	switch (dir){
		case 0:
			printf("east\n");
			break;
		case 1:
			printf("south\n");
			break;
		case 2:
			printf("west\n");
			break;
		case 3:
			printf("north\n");
			break;
		case -1:
			printf("Oh!");
			break;
		default:
			printf("error\n");
	}


}

void test_route_serch_to_center(void){
	int start[2],goal[2];
	int dir;
	int map_data[LENGTH_OF_MAP][LENGTH_OF_MAP];	//mapデータ収納配列
	map_store_read(map_data,LENGTH_OF_MAP*LENGTH_OF_MAP);	//mapデータを収納
	

	printf("Please input start pos\nx:");
	scanf("%d",&start[0]);
	printf("y:");
	scanf("%d",&start[1]);
/*
	printf("Please input goal pos\nx:");
	scanf("%d",&goal[0]);
	printf("y:");
	scanf("%d",&goal[1]);
*/
	goal[0]=CENTER_OF_THE_MAP;
	goal[1]=CENTER_OF_THE_MAP;

	int state=1;
	while(state){
		dir=route_serch_dir(start[0]+start[1]*LENGTH_OF_MAP,goal[0]+goal[1]*LENGTH_OF_MAP,map_data);
		printf("(%d,%d) ",start[0],start[1]);
		printf("Direction of route is ");
		switch (dir){
			case 0:
				printf("east\n");
				start[0]++;
				break;
			case 1:
				printf("south\n");
				start[1]++;
				break;
			case 2:
				printf("west\n");
				start[0]--;
				break;
			case 3:
				printf("north\n");
				start[1]--;
				break;
			case -1:
				printf("Oh!\n");
				state=0;
				break;
			default:
				printf("error\n");
		}
	}

}

















