#include <math.h>
#include <cv.h>
#include <highgui.h>

int circleDetect(){

	CvMemStorage *storage;
	CvSeq *circles = 0;
	int i;
	float *p;
  IplImage*  src_img_gaus = cvLoadImage ("./img/input.jpg", CV_LOAD_IMAGE_GRAYSCALE);
  if (src_img_gaus == 0)
    exit (-1);
  IplImage* src_img = cvLoadImage ("./img/input.jpg", CV_LOAD_IMAGE_COLOR);

	cvSmooth (src_img, src_img_gaus, CV_GAUSSIAN, 5, 0, 0, 0);
	storage = cvCreateMemStorage (0);
	circles = cvHoughCircles (src_img_gaus, storage, CV_HOUGH_GRADIENT,
                            1, 100, 20, 50, 10, MAX (src_img_gaus->width, src_img_gaus->height));
 	for (i = 0; i < circles->total; i++) {
    		p = (float *) cvGetSeqElem (circles, i);
    		cvCircle (src_img, cvPoint (cvRound (p[0]), cvRound (p[1])), 3, CV_RGB (0, 255, 0), -1, 8, 0);
  		cvCircle (src_img, cvPoint (cvRound (p[0]), cvRound (p[1])), cvRound (p[2]), CV_RGB (255, 0, 0), 3, 8, 0);
  }

//	CvSeq *results=cvHoughCircles(
//		src_img,
//		storage,
//		CV_HOUGH_GRADIENT,
//		2,
//		src_img->width/10
//		);
//		for(int o=0;i<resurts->total;i++){
//			float *p=(float*)cvGetSeqElem(results,i);
//			CvPoint pt = cvPoint(cvRound(p[0]),cvRound(p[1]));
//			cvCircle(
//				src_img,
//				pt,
//				cvRound(p[2]),
//				CV_RGB(0xff,0xff,0xff),
//				100,
//				300,
//				area_min,
//				area_max
//			);
//		}
		cvNamedWindow("circle",1);
		cvShowImage("circle",src_img);
  cvDestroyWindow ("circles");
  cvReleaseImage (&src_img);
  cvReleaseImage (&src_img_gaus);
  cvReleaseMemStorage (&storage);

	cvWaitKey(0);


}
