/*
 * debug.h
 *
 *  Created on: 2013/12/28
 *      Author: d10130
 *
 * デバッグ用ヘッダ
 */

#ifndef DEBUG_H_
#define DEBUG_H_

#include <stdio.h>

#define DEBUG_PRINT(...)\
	do{ fprintf(stderr,"DEBUG: %s(%s:%d): ",__func__,__FILE__,__LINE__);\
	fprintf(stderr,__VA_ARGS__); }while(0)

#define ERROR_PRINT(...)\
	do{ fprintf(stderr,"ERROR: %s(%s:%d): ",__func__,__FILE__,__LINE__);\
	fprintf(stderr,__VA_ARGS__); }while(0)

#endif /* DEBUG_H_ */
