#include"header/motor_ctrl_thread.h"

void motor_ctrl(void){
	extern int extern_motor_vector[2];	//大域変数 {速度,角度(degree)}
	double vel_x=0,vel_y=0,vel_th=0;	//x方向速度,y方向速度,θ方向速度
	double mt_pow[4]={0,0,0,0};//モータ出力{l,r,f,b}	

	extern int extern_camera_state;	//大域変数 -1:怪盗なし 1:怪盗あり

	int dir_origin=0;////初期方位

	while (1){
		vel_x=(double)extern_motor_vector[0]*cos((double)extern_motor_vector[1]*PI/180);	//x
		vel_y=(double)extern_motor_vector[0]*sin((double)extern_motor_vector[1]*PI/180);	//y
		vel_th=dir_adj_v_calculate((extern_camera_state==0)?dir_origin:dir_origin+extern_motor_vector[1]);//th 速度取得

		vel_x=(127-LENGTH_OF_ARM*vel_th)*vel_x/100;	//遠慮
		vel_y=(127-LENGTH_OF_ARM*vel_th)*vel_y/100;	//遠慮

		motor_drive(/*u_l,u_r ,u_f,u_b*/(-1)*vel_y+LENGTH_OF_ARM*vel_th,vel_y+LENGTH_OF_ARM*vel_th,(-1)*vel_x+LENGTH_OF_ARM*vel_th,vel_x+LENGTH_OF_ARM*vel_th);	//モータに指令値を送信
		usleep(1000);
	}
}
