#include"header/route_serch.h"

//返り値=0123:東南西北
//	=-1:ゴールとスタートが一致

int route_serch_dir(int start,int goal,int *map_data){
	int start_pos[2]={start%LENGTH_OF_MAP,start/LENGTH_OF_MAP};//スタート地点の座標
	int goal_pos[2] ={ goal%LENGTH_OF_MAP, goal/LENGTH_OF_MAP};//ゴール
//	int diff[2]={goal_pos[0]-start_pos[0],goal_pos[1]-start_pos[1]};//ゴールとスターとの差

	int pos_val=0;



	if (colli_detect(start_pos,1,7,4,4)==1){	//左

		if(mannaka_lr(start_pos)==3) return 3;

		else if (mannaka_lr(start_pos)==1) return 1;

		else if(colli_detect(goal_pos,1,7,4,4)==1) return route_serch(start_pos[0],start_pos[1],goal_pos[0],goal_pos[1]);

		else return 0;

	}


	if (colli_detect(start_pos,6,6,6,6)==1){	//真ん中
		if (colli_detect(goal_pos,6,6,6,6)==1){
			return route_serch(start_pos[0],start_pos[1],goal_pos[0],goal_pos[1]);
		}
	}


	if (colli_detect(start_pos,13,7,4,4)==1){	//右

		if(mannaka_lr(start_pos)==3) return 3;

		else if (mannaka_lr(start_pos)==1) return 1;

		else if (colli_detect(goal_pos,13,7,4,4)==1) return route_serch(start_pos[0],start_pos[1],goal_pos[0],goal_pos[1]);
		
		else return 2;
	}


	if (colli_detect(start_pos,7,1,4,4)==1){	//上

		if(mannaka_fb(start_pos)==0) return 0;

		else if (mannaka_fb(start_pos)==2) return 2;

		else if (colli_detect(goal_pos,7,1,16,4)==1)return route_serch(start_pos[0],start_pos[1],goal_pos[0],goal_pos[1]);
		
		else return 1;
	}


	if (colli_detect(start_pos,7,13,4,4)==1){	//下

		if(mannaka_fb(start_pos)==0) return 0;

		else if (mannaka_fb(start_pos)==2) return 2;

		else if (colli_detect(start_pos,7,13,16,4)==1) return route_serch(start_pos[0],start_pos[1],goal_pos[0],goal_pos[1]);
		
		else return 3;
	}


	if (colli_detect(start_pos,1,1,5,5)==1){	//左上
		return upper_left(start_pos[0],start_pos[1]);
	}
	if (colli_detect(start_pos,12,1,5,5)==1){	//右上
		return upper_right(start_pos[0],start_pos[1]);
	}
	if (colli_detect(start_pos,1,12,5,5)==1){	//左下
		if((start_pos[0]==3 && start_pos[1]==17) || (start_pos[0]==3 && start_pos[1]==16))  return 3;
		else return lower_left(start_pos[0],start_pos[1]);
	}
	if (colli_detect(start_pos,12,12,5,5)==1){	//右下
		if((start_pos[0]==17 && start_pos[1]==15) || (start_pos[0]==16 && start_pos[1]==15)) return 2;
		else return lower_right(start_pos[0],start_pos[1]);
	}


}

int route_serch(int st_x,int st_y,int gl_x,int gl_y){
	
	if (st_x!=gl_x){
		return (st_x<gl_x)?0:2;
	}else if (st_y!=gl_y){
		return (st_y<gl_y)?1:3;
	}else {
		return -1;
	}
}

int route_search2(int st_x,int st_y,int gl_x,int gl_y){

	if (st_y!=gl_y){
		return (st_y<gl_y)?1:3;
	}else if (st_x!=gl_x){
		return (st_x<gl_x)?0:2;
	}else {
		return -1;
	}

}


int colli_detect(int *pos,int box_x,int box_y,int len_x,int len_y){
	if(box_x<=pos[0]&&box_y<=pos[1]&&pos[0]<=box_x+len_x&&pos[1]<=box_y+len_y){
		return 1;
	}else return 4;
}

int mannaka_fb(int *pos){
	if(pos[0]==7 || pos[0]==8)		return 0;	//東へ	
	else if(pos[0]==10 || pos[0]==11)	return 2;	//西へ
	else return 4;
}


int mannaka_lr(int *pos){
	if(pos[1]==7 || pos[1]==8)		return 1;	//南へ
	else if(pos[1]==10 || pos[1]==11) 	return 3;	//北へ
	else return 4;
}

int upper_left(int st_x,int st_y){
	return route_search2(st_x,st_y,7,3);
}

int upper_right(int st_x,int st_y){
	return route_serch(st_x,st_y,15,7);
}

int lower_left(int st_x,int st_y){
	return route_serch(st_x,st_y,1,11);
}

int lower_right(int st_x,int st_y){
	return route_search2(st_x,st_y,11,17);
}







